---
type: api
title: Get multiple documents
description: **All methods and paths for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v9/operation/operation-mget
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v9/operation/operation-mget
products:
  - Elasticsearch
---

# Get multiple documents


Availability: 1.3+

## Paths

- `POST` (also `GET`) `/{index}/_mget`
- `POST` (also `GET`) `/_mget`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v9/authentication#apikeyauth)
- [Basic auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v9/authentication#basicauth)
- [Bearer auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v9/authentication#bearerauth)

#### Path Parameters

- `index` (string IndexName) — optional, leave it out to use `/_mget`
  Name of the index to retrieve documents from when `ids` are specified, or when a document in the `docs` array does not specify an index.

## Description

Get multiple JSON documents by ID from one or more indices.
If you specify an index in the request URI, you only need to specify the document IDs in the request body.
To ensure fast responses, this multi get (mget) API responds with partial results if one or more shards fail.

**Filter source fields**

By default, the `_source` field is returned for every document (if stored).
Use the `_source` and `_source_include` or `source_exclude` attributes to filter what fields are returned for a particular document.
You can include the `_source`, `_source_includes`, and `_source_excludes` query parameters in the request URI to specify the defaults to use when there are no per-document instructions.

**Get stored fields**

Use the `stored_fields` attribute to specify the set of stored fields you want to retrieve.
Any requested fields that are not stored are ignored.
You can include the `stored_fields` query parameter in the request URI to specify the defaults to use when there are no per-document instructions.

## Required authorization

* Index privileges: `read`

## Query String Parameters

- `preference` (string)
  Specifies the node or shard the operation should be performed on. Random by default.
- `realtime` (boolean · default: true)
  If `true`, the request is real-time as opposed to near-real-time.
- `refresh` (boolean · default: false)
  If `true`, the request refreshes relevant shards before retrieving documents.
- `routing` (union Routing)
  Custom value used to route operations to a specific shard.
Not allowed when `index.slice.enabled` is `true` for the target index; use `_slice` instead.
  One of: `string` or `string[]`
- `_source` (union SourceConfigParam)
  True or false to return the `_source` field or not, or a list of fields to return.
  One of: `boolean` or `Fields`
- `_source_excludes` (union Fields)
  A comma-separated list of source fields to exclude from the response.
You can also use this parameter to exclude fields from the subset specified in `_source_includes` query parameter.
  One of: `Field` or `Field[]`
- `_source_includes` (union Fields)
  A comma-separated list of source fields to include in the response.
If this parameter is specified, only these source fields are returned. You can exclude fields from this subset using the `_source_excludes` query parameter.
If the `_source` parameter is `false`, this parameter is ignored.
  One of: `Field` or `Field[]`
- `stored_fields` (string Fields · default: false)
  If `true`, retrieves the document fields stored in the index rather than the document `_source`.

## Request Body

`application/json`

- `docs` ([] Operation) — optional
  The documents you want to retrieve. Required if no index is specified in the request URI.
  - `_id` (string Id) — required
    The unique document ID.
  - `_index` (string IndexName) — optional
    The index that contains the document.
  - `routing` (string Routing) — optional
    The key for the primary shard the document resides on. Required if routing is used during indexing.
  - `_source` (SourceConfig) — optional
    If `false`, excludes all _source fields.
  - `stored_fields` (string Fields) — optional
    The stored fields you want to retrieve.
  - `version` (number VersionNumber) — optional
  - `version_type` (enum VersionType) — optional
    

Supported values include:
  - `internal`: Use internal versioning that starts at 1 and increments with each update or delete.
  - `external`: Only index the document if the specified version is strictly higher than the version of the stored document or if there is no existing document.
  - `external_gte`: Only index the document if the specified version is equal or higher than the version of the stored document or if there is no existing document.
NOTE: The `external_gte` version type is meant for special use cases and should be used with care.
If used incorrectly, it can result in loss of data.
    Values: `internal`, `external`, `external_gte`
- `ids` (string Ids) — optional
  The IDs of the documents you want to retrieve. Allowed when the index is specified in the request URI.

## Response

`application/json`

- `docs` ([] union ResponseItem)
  The response includes a docs array that contains the documents in the order specified in the request.
The structure of the returned documents is similar to that returned by the get API.
If there is a failure getting a particular document, the error is included in place of the document.
  - **GetResult**
    - `_index` (string IndexName)
      The name of the index the document belongs to.
    - `fields` (map string to object)
      If the `stored_fields` parameter is set to `true` and `found` is `true`, it contains the document fields stored in the index.
    - `_ignored` ([] string)
    - `found` (boolean)
      Indicates whether the document exists.
    - `_id` (string Id)
      The unique identifier for the document.
    - `_primary_term` (number)
      The primary term assigned to the document for the indexing operation.
    - `_routing` (string)
      The explicit routing, if set.
    - `_seq_no` (number SequenceNumber)
      The sequence number assigned to the document for the indexing operation.
Sequence numbers are used to ensure an older version of a document doesn't overwrite a newer version.
    - `_source` (object)
      If `found` is `true`, it contains the document data formatted in JSON.
If the `_source` parameter is set to `false` or the `stored_fields` parameter is set to `true`, it is excluded.
    - `_version` (number VersionNumber)
      The document version, which is ncremented each time the document is updated.
  - **MultiGetError**
    - `error` ({} ErrorCause)
      - `type` (string)
        The type of error
      - `reason` (union string) — nullable
        A human-readable explanation of the error, in English.
        One of: `string`
      - `stack_trace` (string)
        The server stack trace. Present only if the `error_trace=true` parameter was sent with the request.
      - `caused_by` ({} ErrorCause) — recursive
        Same fields as `error` in `MultiGetError`
      - `root_cause` ([] ErrorCause) — recursive
        Same fields as `error` in `MultiGetError`
      - `suppressed` ([] ErrorCause) — recursive
        Same fields as `error` in `MultiGetError`
    - `_id` (string Id)
    - `_index` (string IndexName)
## Code Examples

#### Console

```console
POST /my-index-000001/_mget
{
  "docs": [
    {
      "_id": "1"
    },
    {
      "_id": "2"
    }
  ]
}
```

#### JavaScript

```javascript
const response = await client.mget({
  index: "my-index-000001",
  docs: [
    {
      _id: "1",
    },
    {
      _id: "2",
    },
  ],
});
```

#### Python

```python
resp = client.mget(
    index="my-index-000001",
    docs=[
        {
            "_id": "1"
        },
        {
            "_id": "2"
        }
    ],
)
```

#### curl

```curl
curl -X POST "$ELASTICSEARCH_URL/my-index-000001/_mget" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "docs": [
      {
        "_id": "1"
      },
      {
        "_id": "2"
      }
    ]
  }'
```

#### Java

```java
client.mget(m -> m
    .docs(List.of(MultiGetOperation.of(mu -> mu
            .id("1")
        ),MultiGetOperation.of(mu -> mu
            .id("2")
        )))
    .index("my-index-000001")
);
```

#### C#

```c#
var response = await client
    .MultiGetAsync<MyDocument>(d1 => d1
        .Index("my-index-000001")
        .Docs(d2 => d2
            .Id("1"), d2 => d2
            .Id("2")
        )
    );
```

#### PHP

```php
$resp = $client->mget([
    "index" => "my-index-000001",
    "body" => [
        "docs" => array(
            [
                "_id" => "1",
            ],
            [
                "_id" => "2",
            ],
        ),
    ],
]);
```

#### Ruby

```ruby
response = client.mget(
  index: "my-index-000001",
  body: {
    "docs": [
      {
        "_id": "1"
      },
      {
        "_id": "2"
      }
    ]
  }
)
```

